//+------------------------------------------------------------------+
//|                                                         Fibo.mq4 |
//|                               Copyright 2015, Vladimir Gribachev |
//|                                         http://moneystrategy.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Vladimir Gribachev"
#property link      "http://moneystrategy.ru/"
#property version   "1.00"
#property strict


input ENUM_TIMEFRAMES  TFSL     = PERIOD_H4;
input ENUM_TIMEFRAMES TFFIBOFILTER = PERIOD_H4;
input int     Depth        = 30;
input int     Deviation    = 5;
input int     Backstep     = 3;
extern int    MinSizeFibo  = 50;
input double  FiboOpenDeal = 50.0;
input double  Lot          = 0.2;
input double  TakeProfit1  = 0.23;
input double  TakeProfit2  = 0.618;
input double  StopLoss     = 61.8;
sinput int    Magic        = 12345;
sinput string Com          = "Fibo";

double Zig,Zag,LastLow,LastHigh,LastWave,PrevAsk=0,PrevBid=0,Zig2,Zag2,LastLow2,LastHigh2,LastWave2,Zig3,Zag3,LastLow3,LastHigh3,LastWave3;
int LowBar,HighBar,Impulse,ticket,LowBar2,HighBar2,Impulse2,LowBar3,HighBar3,Impulse3;
bool res;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(Digits==3 || Digits==5)
     {
      MinSizeFibo*=10;
     };
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(iBars(Symbol(),PERIOD_CURRENT)<50)
     {
      Print("Not enough bars in history, at least 50.");
      return;
     }
//---
   for(int i=0; i<1000; i++)
     {
      Zig=iCustom(NULL,0,"ZigZag",Depth,Deviation,Backstep,2,i);
      if(Zig!=0) {LastLow=Zig; LowBar=i; break;}
     }
//---     
   for(int i=0; i<1000; i++)
     {
      Zag=iCustom(NULL,0,"ZigZag",Depth,Deviation,Backstep,1,i);
      if(Zag!=0) {LastHigh=Zag; HighBar=i; break;}
     }
//---

   if(Zig>Zag) LastWave=NormalizeDouble((LastLow-LastHigh)/Point,Digits);
   if(Zig<Zag) LastWave=NormalizeDouble((LastHigh-LastLow)/Point,Digits);

   if(LowBar>HighBar) Impulse=1;// 
   if(LowBar<HighBar) Impulse=2;// 
                                //Print(Up,Dn);
//---
   if(Impulse==1)
     {
      ObjectDelete("Fibo");
      ObjectCreate("Fibo",OBJ_FIBO,0,iTime(Symbol(),0,LowBar),LastLow,iTime(Symbol(),0,HighBar),LastHigh);
      ObjectSet("Fibo",OBJPROP_COLOR,clrRed);
      ObjectSet("Fibo",OBJPROP_WIDTH,1);
      ObjectSet("Fibo",OBJPROP_STYLE,2);
     }
//---
   if(Impulse==2)
     {
      ObjectDelete("Fibo");
      ObjectCreate("Fibo",OBJ_FIBO,0,iTime(Symbol(),0,HighBar),LastHigh,iTime(Symbol(),0,LowBar),LastLow);
      ObjectSet("Fibo",OBJPROP_COLOR,clrRed);
      ObjectSet("Fibo",OBJPROP_WIDTH,1);
      ObjectSet("Fibo",OBJPROP_STYLE,2);
     };
     
   for(int i=0; i<1000; i++)
     {
      Zig2=iCustom(NULL,TFFIBOFILTER,"ZigZag",Depth,Deviation,Backstep,2,i);
      if(Zig2!=0) {LastLow2=Zig2; LowBar2=i; break;}
     }
//---     
   for(int i=0; i<1000; i++)
     {
      Zag2=iCustom(NULL,TFFIBOFILTER,"ZigZag",Depth,Deviation,Backstep,1,i);
      if(Zag2!=0) {LastHigh2=Zag2; HighBar2=i; break;}
     }
//---

   if(Zig2>Zag2) LastWave2=NormalizeDouble((LastLow2-LastHigh2)/Point,Digits);
   if(Zig2<Zag2) LastWave2=NormalizeDouble((LastHigh2-LastLow2)/Point,Digits);

   if(LowBar2>HighBar2) Impulse2=1;// 
   if(LowBar2<HighBar2) Impulse2=2;// 
     

//Print(LastLow+NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits));

   if(Impulse==1 && Impulse2==1 && LastWave>MinSizeFibo && CountBuy()==0)
     {
      if(Ask<=LastHigh-NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits) && PrevAsk>=LastHigh-NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits))
        {
         if(AccountFreeMarginCheck(Symbol(),OP_BUY,Lot)<=0){Print("Not enough money.");return;}
         ticket=OrderSend(Symbol(),OP_BUY,Lot,Ask,0,0,0,Com,Magic,0,clrNONE);
        }
     }

   if(Impulse==2 && Impulse2==2 && LastWave>MinSizeFibo && CountSell()==0)
     {
      if(Bid>=LastLow+NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits) && PrevBid<=LastLow+NormalizeDouble(FiboOpenDeal*LastWave*Point/100,Digits))
        {
         if(AccountFreeMarginCheck(Symbol(),OP_SELL,Lot)<=0){Print("Not enough money.");return;}
         ticket=OrderSend(Symbol(),OP_SELL,Lot,Bid,0,0,0,Com,Magic,0,clrNONE);
        }
     }
//---

  for(int i=0; i<1000; i++)
     {
      Zig3=iCustom(NULL,TFFIBOFILTER,"ZigZag",Depth,Deviation,Backstep,2,i);
      if(Zig3!=0) {LastLow3=Zig3; LowBar3=i; break;}
     }
//---     
   for(int i=0; i<1000; i++)
     {
      Zag3=iCustom(NULL,TFFIBOFILTER,"ZigZag",Depth,Deviation,Backstep,1,i);
      if(Zag3!=0) {LastHigh3=Zag3; HighBar3=i; break;}
     }
//---

   if(Zig3>Zag3) LastWave3=NormalizeDouble((LastLow3-LastHigh3)/Point,Digits);
   if(Zig3<Zag3) LastWave3=NormalizeDouble((LastHigh3-LastLow3)/Point,Digits);

   if(LowBar3>HighBar3) Impulse3=1;// 
   if(LowBar3<HighBar3) Impulse3=2;// 
//---
   
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
           {
            if(OrderType()==OP_BUY&&Impulse==1)
              {
               if(Bid<=LastHigh-NormalizeDouble(StopLoss*LastWave*Point/100,Digits) && PrevBid>=LastHigh-NormalizeDouble(StopLoss*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Bid,0,clrNONE);
                 }
               if(Bid<=LastHigh-NormalizeDouble(TakeProfit1*LastWave*Point/100,Digits) && PrevBid>=LastHigh-NormalizeDouble(TakeProfit1*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),(OrderLots()/2),Bid,0,clrNONE);
                 } 
               if(Bid<=LastHigh-NormalizeDouble(TakeProfit2*LastWave*Point/100,Digits) && PrevBid>=LastHigh-NormalizeDouble(TakeProfit2*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Bid,0,clrNONE);
                 }    
              }

            if(OrderType()==OP_SELL&&Impulse==2)
              {
                if(Ask>=LastLow+NormalizeDouble(StopLoss*LastWave*Point/100,Digits) && PrevAsk<=LastLow+NormalizeDouble(StopLoss*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Ask,0,clrNONE);
                 }
                if(Ask>=LastLow+NormalizeDouble(TakeProfit1*LastWave*Point/100,Digits) && PrevAsk<=LastLow+NormalizeDouble(TakeProfit1*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),(OrderLots()/2),Ask,0,clrNONE);
                 } 
                if(Ask>=LastLow+NormalizeDouble(TakeProfit2*LastWave*Point/100,Digits) && PrevAsk<=LastLow+NormalizeDouble(TakeProfit2*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Ask,0,clrNONE);
                 }   
              }
            if(OrderType()==OP_BUY&&Impulse3==1)
              {
              if(iClose(_Symbol,TFSL,0)<=LastHigh-NormalizeDouble(StopLoss*LastWave*Point/100,Digits) && PrevBid>=LastHigh-NormalizeDouble(StopLoss*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Bid,0,clrNONE);
                 }
              } 
            if(OrderType()==OP_SELL&&Impulse3==2)
              {
              if(iClose(_Symbol,TFSL,0)>=LastLow+NormalizeDouble(StopLoss*LastWave*Point/100,Digits) && PrevAsk<=LastLow+NormalizeDouble(StopLoss*LastWave*Point/100,Digits))
                 {
                  res=OrderClose(OrderTicket(),OrderLots(),Ask,0,clrNONE);
                 }
              
              }   
           }
     }

   PrevAsk=Ask;
   PrevBid=Bid;
  }
//+------------------------------------------------------------------+
int CountBuy()
  {
   int count = 0;
   for(int i = OrdersTotal() - 1; i >= 0; i --)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==Magic)
            count++;
        }
     }
   return (count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountSell()
  {
   int count = 0;
   for(int i = OrdersTotal() - 1; i >= 0; i --)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==Magic)
            count++;
        }
     }
   return (count);
  }
//+------------------------------------------------------------------+
